VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsMsgBox"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'
' MsgBox Class
' Copyright  1995-1996 Gregg Irwin. All Rights Reserved.
'
Option Explicit
DefInt A-Z

#If Win16 Then
    Private Declare Function MessageBox Lib "user" (ByVal HWnd As Integer, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Integer) As Integer
#ElseIf Win32 Then
    Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal HWnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
#End If

'* PROPERTIES   *
' .HwndOwner
' .Message
' .StyleFlags
' .Title

'?? Add Helpfile and Context properties ??
' .HelpFile
' .Context
'??

'* METHODS      *
' .ShowModal

Private mHwndOwner  As Long
Private mMessage    As String
Private mTitle      As String
Private mStyle      As Long

'------------------------------------------------
'-- PROPERTIES
'------------------------------------------------

' .HwndOwner
Public Property Let HWndOwner(NewHwndOwner As Long)
    mHwndOwner = NewHwndOwner
End Property

Public Property Get HWndOwner() As Long
    HWndOwner = mHwndOwner
End Property


' .Message
Public Property Let Message(NewMessage As String)
    mMessage = NewMessage
End Property

Public Property Get Message() As String
    Message = mMessage
End Property


' .StyleFlags
Public Property Let Style(NewStyle As Long)
    mStyle = NewStyle
End Property

Public Property Get Style() As Long
    Style = mStyle
End Property


' .Title
Public Property Let Title(NewTitle As String)
    mTitle = NewTitle
End Property

Public Property Get Title() As String
    Title = mTitle
End Property


'------------------------------------------------
'-- METHODS
'------------------------------------------------

' .ShowModal
Public Function ShowModal(Optional Msg As Variant, Optional StyleFlags As Variant, _
                         Optional BoxTitle As Variant, Optional HWnd As Variant) As Long
    
    Call FillMissingParmsFromProps(Msg, StyleFlags, BoxTitle, HWnd)

    '!! A Null Msg will cause a GPF so we have to check for null
    '   string parameters and pass vbNullChar in their place.
    If Len(Msg) Then
        If Len(BoxTitle) Then
            ShowModal = MessageBox(CLng(HWnd), CStr(Msg), CStr(BoxTitle), StyleFlags)
        Else
            ShowModal = MessageBox(CLng(HWnd), CStr(Msg), vbNullChar, StyleFlags)
        End If
    Else
        If Len(BoxTitle) Then
            ShowModal = MessageBox(CLng(HWnd), vbNullChar, CStr(BoxTitle), StyleFlags)
        Else
            ShowModal = MessageBox(CLng(HWnd), vbNullChar, vbNullChar, StyleFlags)
        End If
    End If

End Function


'------------------------------------------------
'-- INTERNAL SUPPORT PROCEDURES
'------------------------------------------------

Private Sub FillMissingParmsFromProps(Optional Msg As Variant, Optional StyleFlags As Variant, _
                                      Optional BoxTitle As Variant, Optional HWnd As Variant)
'------------------------------------------------------
'-- Fill any missing parameters with the value from
'   their associated property.
'------------------------------------------------------
    
    If IsMissing(Msg) Then
        Msg = Me.Message
    End If
    
    If IsMissing(StyleFlags) Then
        StyleFlags = Me.Style
    End If
    
    If IsMissing(BoxTitle) Then
        BoxTitle = Me.Title
    End If
    
    If IsMissing(HWnd) Then
        HWnd = Me.HWndOwner
    End If

End Sub
